com.orsoncharts.data

## Interface KeyedValues3D<T>

- All Superinterfaces:
    Values3D<T>
  All Known Subinterfaces:
    CategoryDataset3D
  All Known Implementing Classes:
    DefaultKeyedValues3D, StandardCategoryDataset3D

      public interface KeyedValues3D<T>
      extends Values3D<T>

  A three dimensional cube of data values where each value is uniquely identified by three keys (the `seriesKey`, `rowKey` and `columnKey`).

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getColumnIndex(java.lang.Comparable<?> columnkey)` Returns the index of the specified column key, or `-1` if there is no matching key.
    `java.lang.Comparable<?>` | `getColumnKey(int columnIndex)` Returns the column key with the specified index.
    `java.util.List<java.lang.Comparable<?>>` | `getColumnKeys()` Returns a list of the column keys for the dataset.
    `int` | `getRowIndex(java.lang.Comparable<?> rowkey)` Returns the index of the specified row key, or `-1` if there is no matching key.
    `java.lang.Comparable<?>` | `getRowKey(int rowIndex)` Returns the row key with the specified index.
    `java.util.List<java.lang.Comparable<?>>` | `getRowKeys()` Returns a list of the row keys for the dataset.
    `int` | `getSeriesIndex(java.lang.Comparable<?> serieskey)` Returns the index of the specified series key, or `-1` if there is no matching key.
    `java.lang.Comparable<?>` | `getSeriesKey(int seriesIndex)` Returns the series key with the specified index.
    `java.util.List<java.lang.Comparable<?>>` | `getSeriesKeys()` Returns a list of the series keys for the dataset.
    `T` | `getValue(java.lang.Comparable<?> seriesKey, java.lang.Comparable<?> rowKey, java.lang.Comparable<?> columnKey)` Returns the value for a given series, row and column.

    - ### Methods inherited from interface com.orsoncharts.data.Values3D

      `getColumnCount, getDoubleValue, getRowCount, getSeriesCount, getValue`

- - ### Method Detail

    - #### getSeriesKeys

          java.util.List<java.lang.Comparable<?>> getSeriesKeys()

      Returns a list of the series keys for the dataset. Modifying this list will have no impact on the underlying dataset.
      Returns:
        A list of the series keys (possibly empty, but never `null`).

    - #### getRowKeys

          java.util.List<java.lang.Comparable<?>> getRowKeys()

      Returns a list of the row keys for the dataset. Modifying this list will have no impact on the underlying dataset.
      Returns:
        A list of the row keys (possibly empty, but never `null`).

    - #### getColumnKeys

          java.util.List<java.lang.Comparable<?>> getColumnKeys()

      Returns a list of the column keys for the dataset. Modifying this list will have no impact on the underlying dataset.
      Returns:
        A list of the column keys (possibly empty, but never `null`).

    - #### getSeriesKey

          java.lang.Comparable<?> getSeriesKey(int seriesIndex)

      Returns the series key with the specified index.
      Parameters:
        `seriesIndex` - the series index.
      Returns:
        The key.

    - #### getRowKey

          java.lang.Comparable<?> getRowKey(int rowIndex)

      Returns the row key with the specified index.
      Parameters:
        `rowIndex` - the row index.
      Returns:
        The key.

    - #### getColumnKey

          java.lang.Comparable<?> getColumnKey(int columnIndex)

      Returns the column key with the specified index.
      Parameters:
        `columnIndex` - the column index.
      Returns:
        The key.

    - #### getSeriesIndex

          int getSeriesIndex(java.lang.Comparable<?> serieskey)

      Returns the index of the specified series key, or `-1` if there is no matching key.
      Parameters:
        `serieskey` - the series key (`null` not permitted).
      Returns:
        The key index, or `-1`.

    - #### getRowIndex

          int getRowIndex(java.lang.Comparable<?> rowkey)

      Returns the index of the specified row key, or `-1` if there is no matching key.
      Parameters:
        `rowkey` - the row key (`null` not permitted).
      Returns:
        The row index or `-1`.

    - #### getColumnIndex

          int getColumnIndex(java.lang.Comparable<?> columnkey)

      Returns the index of the specified column key, or `-1` if there is no matching key.
      Parameters:
        `columnkey` - the column key (`null` not permitted).
      Returns:
        The column index or `-1`.

    - #### getValue

          T getValue(java.lang.Comparable<?> seriesKey,
                     java.lang.Comparable<?> rowKey,
                     java.lang.Comparable<?> columnKey)

      Returns the value for a given series, row and column.
      Parameters:
        `seriesKey` - the series key (`null` not permitted).
        `rowKey` - the row key (`null` not permitted).
        `columnKey` - the column key (`null` not permitted).
      Returns:
        The value (possibly `null`).